'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createMiddleware;

var _checkForNonFunctions = require('./checkForNonFunctions');

var _checkForNonFunctions2 = _interopRequireDefault(_checkForNonFunctions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createMiddleware(actionHandlers) {
  if (process.env.NODE_ENV !== 'production') (0, _checkForNonFunctions2.default)(actionHandlers, 'actionHandlers');

  var result = function result(store) {
    return function (next) {
      return function (action) {
        var handler = actionHandlers[action.type];
        if (!handler) return next(action);
        return handler(store)(next)(action);
      };
    };
  };
  result.actionHandlers = actionHandlers;
  return result;
}